package de.jatitv.opsecurity.listener;

import de.jatitv.opsecurity.Util;
import de.jatitv.opsecurity.config.config.SelectConfig;
import de.jatitv.opsecurity.config.languages.SelectMessages;
import de.jatitv.opsecurity.system.Main;
import de.jatitv.opsecurity.system.Permissions;
import net.t2code.lib.Spigot.Lib.commands.Cmd;
import net.t2code.lib.Spigot.Lib.messages.send;
import net.t2code.lib.Spigot.Lib.replace.Replace;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

public class CheckOLD {
    public static Boolean onCheck(Player player, Boolean join) {
        if (SelectConfig.opWhitelistEnable) {
            if (player.isOp()) {
                if (checkOpWhitelist(player)) {
                    return false;
                }
                if (join) {
                    send.console(Replace.replace(Util.getPrefix(),SelectMessages.opConsoleOnJoin.replace("[player]", player.getName())));
                }
                if (SelectConfig.notifyWarn) {
                    for (Player notifyperm : Bukkit.getOnlinePlayers()) {
                        if (notifyperm.hasPermission(Permissions.notify)) {
                            if (join) {
                                notifyperm.sendMessage(Replace.replace(Util.getPrefix(),SelectMessages.opConsoleOnJoin.replace("[player]", player.getName())));
                            } else notifyperm.sendMessage(Replace.replace(Util.getPrefix(),SelectMessages.OP_consoleKick.replace("[player]", player.getName())));
                            if (SelectConfig.notifySoundEnable) {
                                notifyperm.playSound(player.getLocation(), SelectConfig.notifySound, 3, 1);
                            }
                        }
                    }
                }
                if (SelectConfig.nooPPlayerKick && SelectConfig.noOPPlayerDeop) {
                    player.setOp(false);
                    Cmd.console(SelectConfig.kickCommand.replace("[player]", player.getName())
                            .replace("[reason]", Replace.replace(Util.getPrefix(),SelectMessages.OP_kick + "\n" + "\n" + SelectMessages.OP_deop)));
                    send.console(Replace.replace(Util.getPrefix(),SelectMessages.OP_consoleKick.replace("[player]", player.getName())));
                    return true;
                } else {
                    if (SelectConfig.nooPPlayerKick) {
                        Cmd.console(SelectConfig.kickCommand.replace("[player]", player.getName()).replace("[reason]", Replace.replace(Util.getPrefix(),SelectMessages.OP_kick)));
                        send.console(Replace.replace(Util.getPrefix(),SelectMessages.OP_consoleKick.replace("[player]", player.getName())));
                        for (Player notifyperm : Bukkit.getOnlinePlayers()) {
                            if (notifyperm.hasPermission(Permissions.notify)) {
                                notifyperm.sendMessage(Replace.replace(Util.getPrefix(),SelectMessages.OP_consoleKick.replace("[player]", player.getName())
                                        + "\n" + SelectMessages.OP_consoleDeop.replace("[player]", player.getName())));
                            }
                        }
                        return true;
                    }
                    if (SelectConfig.noOPPlayerDeop) {
                        player.setOp(false);
                        if (SelectConfig.sendPlayerDEOPmsg) {
                            new BukkitRunnable() {
                                @Override
                                public void run() {
                                    player.sendMessage(Replace.replace(Util.getPrefix(),SelectMessages.OP_deop));
                                }
                            }.runTaskLater(Main.plugin, 5L);

                        }
                        send.console(Replace.replace(Util.getPrefix(),SelectMessages.OP_consoleDeop.replace("[player]", player.getName())));
                        for (Player notifyperm : Bukkit.getOnlinePlayers()) {
                            if (notifyperm.hasPermission(Permissions.notify)) {
                                notifyperm.sendMessage(Replace.replace(Util.getPrefix(),SelectMessages.OP_consoleDeop.replace("[player]", player.getName())));
                            }
                        }
                        return true;
                    }
                }
                if (SelectConfig.customCommandEnable) {
                    new BukkitRunnable() {
                        @Override
                        public void run() {
                            for (String cmd : SelectConfig.customKickCommand) {
                                Cmd.console(Replace.replace(Util.getPrefix(),cmd.replace("[player]", player.getName())));
                            }
                        }
                    }.runTaskLater(Main.plugin, 5L);
                    return true;
                }
            }
        }

        if (SelectConfig.permissionWhitelistEnable) {
            for (String s : SelectConfig.permissions) {
                if (player.hasPermission(s)) {
                    if (!checkPermWhitelist(player)) {
                        if (join) {
                            send.console(Replace.replace(Util.getPrefix(),SelectMessages.Perm_consoleOnJoin.replace("[player]", player.getName()).replace("[perm]", s)));
                        }
                        if (SelectConfig.notifyWarn) {
                            for (Player notifyperm : Bukkit.getOnlinePlayers()) {
                                if (notifyperm.hasPermission(Permissions.notify)) {
                                    if (join) {
                                        notifyperm.sendMessage(Replace.replace(Util.getPrefix(),SelectMessages.Perm_consoleOnJoin.replace("[player]",
                                                player.getName()).replace("[perm]", s)));
                                    } else notifyperm.sendMessage(Replace.replace(Util.getPrefix(),SelectMessages.Perm_consoleKick.replace("[player]",
                                            player.getName()).replace("[perm]", s)));
                                    if (SelectConfig.notifySoundEnable) {
                                        notifyperm.playSound(player.getLocation(), SelectConfig.notifySound, 3, 1);
                                    }
                                }
                            }
                        }
                        if (SelectConfig.PlayerWhithPermission_kick && SelectConfig.permCommandEnable) {
                            Cmd.console(SelectConfig.kickCommand.replace("[player]", player.getName()).replace("[reason]", Replace.replace(Util.getPrefix(),SelectMessages.Perm_kick)));
                            send.console(Replace.replace(Util.getPrefix(),SelectMessages.Perm_consoleKick.replace("[player]",
                                    player.getName()).replace("[perm]", s)));
                            for (String cmd : SelectConfig.permCommand) {
                                Bukkit.getServer().dispatchCommand(Bukkit.getServer().getConsoleSender(), cmd.replace("[player]", player.getName()).replace("[perm]", s));
                            }
                            return true;

                        }
                        if (SelectConfig.PlayerWhithPermission_kick) {
                            Cmd.console(SelectConfig.kickCommand.replace("[player]", player.getName()).replace("[reason]", Replace.replace(Util.getPrefix(),SelectMessages.Perm_kick)));
                            send.console(Replace.replace(Util.getPrefix(),SelectMessages.Perm_consoleKick.replace("[player]",
                                    player.getName()).replace("[perm]", s)));
                            return true;
                        }
                        if (SelectConfig.permCommandEnable) {
                            for (String cmd : SelectConfig.permCommand) {
                                Cmd.console(cmd.replace("[player]", player.getName()).replace("[perm]", s));
                            }
                            return true;
                        }
                        return true;
                    }
                }
            }
        }
        return false;
    }

    private static void opSec(Player player){

    }

    private static Boolean checkOpWhitelist(Player player) {
        if (Main.opHashMap.containsKey(player.getName().toLowerCase())) {
            if (Main.opHashMap.get(player.getName().toLowerCase()).UUID.equals(player.getUniqueId().toString().replace("-", ""))) {
                return true;
            } else {
                send.console(SelectMessages.ExactReason.replace("[reason]", "Player UUID: " + player.getUniqueId().toString() + " not whitelisted"));
                return false;
            }
        } else {
            send.console(SelectMessages.ExactReason.replace("[reason]", "Player name: " + player.getName() + " not whitelisted"));
            return false;
        }
    }

    private static Boolean checkPermWhitelist(Player player) {
        if (Main.permissionHashMap.containsKey(player.getName().toLowerCase())) {
            if (Main.permissionHashMap.get(player.getName().toLowerCase()).UUID.equals(player.getUniqueId().toString().replace("-", ""))) {
                return true;
            } else {
                send.console(SelectMessages.ExactReason.replace("[reason]", "Player UUID: " + player.getUniqueId().toString() + " not whitelisted"));
                return false;
            }
        } else {
            send.console(SelectMessages.ExactReason.replace("[reason]", "Player name: " + player.getName() + " not whitelisted"));
            return false;
        }
    }
}
